Package org.optaplanner.core.impl.score.buildin.simplelong

## Class SimpleLongScoreHolderImpl

- java.lang.Object
- - org.optaplanner.core.impl.score.holder.AbstractScoreHolder<SimpleLongScore>
  - - org.optaplanner.core.impl.score.buildin.simplelong.SimpleLongScoreHolderImpl

- All Implemented Interfaces:
    `SimpleLongScoreHolder`, `ScoreHolder<SimpleLongScore>`

      public final class SimpleLongScoreHolderImpl
      extends AbstractScoreHolder<SimpleLongScore>
      implements SimpleLongScoreHolder

  See Also:
    `SimpleLongScore`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.optaplanner.core.impl.score.holder.AbstractScoreHolder

      `AbstractScoreHolder.BigDecimalMatchExecutor, AbstractScoreHolder.ConstraintActivationUnMatchListener, AbstractScoreHolder.IntMatchExecutor, AbstractScoreHolder.LongMatchExecutor, AbstractScoreHolder.ScoreMatchExecutor<Score_ extends AbstractScore<Score_>>`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected Map<org.kie.api.definition.rule.Rule,​AbstractScoreHolder.LongMatchExecutor>` | `matchExecutorByNumberMap` |
    `protected long` | `score` |

    - ### Fields inherited from class org.optaplanner.core.impl.score.holder.AbstractScoreHolder

      `constraintMatchEnabled, constraintMatchTotalMap, EMPTY_OBJECT_ARRAY, indictmentMap, zeroScore`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `SimpleLongScoreHolderImpl​(boolean constraintMatchEnabled)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext, long weight)` |
    `void` | `configureConstraintWeight​(org.kie.api.definition.rule.Rule rule, SimpleLongScore constraintWeight)` |
    `SimpleLongScore` | `extractScore​(int initScore)` |
    `long` | `getScore()` |
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext, int weightMultiplier, Object... justifications)` | For internal use only, use penalize() or reward() instead.
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext, long weightMultiplier, Object... justifications)` | For internal use only, use penalize() or reward() instead.
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext, Object... justifications)` | For internal use only, use penalize() or reward() instead.
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal weightMultiplier, Object... justifications)` | For internal use only, use penalize() or reward() instead.
    `void` | `penalize​(org.kie.api.runtime.rule.RuleContext kcontext)` | Penalize a match by the `ConstraintWeight` negated.
    `void` | `penalize​(org.kie.api.runtime.rule.RuleContext kcontext, long weightMultiplier)` | Penalize a match by the `ConstraintWeight` negated and multiplied with the weightMultiplier for all score levels.
    `void` | `reward​(org.kie.api.runtime.rule.RuleContext kcontext)` | Reward a match by the `ConstraintWeight`.
    `void` | `reward​(org.kie.api.runtime.rule.RuleContext kcontext, long weightMultiplier)` | Reward a match by the `ConstraintWeight` multiplied with the weightMultiplier for all score levels.

    - ### Methods inherited from class org.optaplanner.core.impl.score.holder.AbstractScoreHolder

      `extractJustificationList, getConstraintMatchTotalMap, getIndictmentMap, impactScore, impactScore, impactScore, impactScore, isConstraintMatchEnabled, registerConstraintMatch`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.api.score.buildin.simplelong.SimpleLongScoreHolder

      `impactScore`

- - ### Field Detail

    - #### matchExecutorByNumberMap

          protected final Map<org.kie.api.definition.rule.Rule,​AbstractScoreHolder.LongMatchExecutor> matchExecutorByNumberMap

    - #### score

          protected long score

  - ### Constructor Detail

    - #### SimpleLongScoreHolderImpl

          public SimpleLongScoreHolderImpl​(boolean constraintMatchEnabled)

  - ### Method Detail

    - #### getScore

          public long getScore()

    - #### configureConstraintWeight

          public void configureConstraintWeight​(org.kie.api.definition.rule.Rule rule,
                                                SimpleLongScore constraintWeight)

      Overrides:
        `configureConstraintWeight` in class `AbstractScoreHolder<SimpleLongScore>`

    - #### penalize

          public void penalize​(org.kie.api.runtime.rule.RuleContext kcontext)

      Description copied from interface: `ScoreHolder`
      Penalize a match by the `ConstraintWeight` negated.
      Specified by:
        `penalize` in interface `ScoreHolder<SimpleLongScore>`
      Parameters:
        `kcontext` - never null, the magic variable in DRL

    - #### penalize

          public void penalize​(org.kie.api.runtime.rule.RuleContext kcontext,
                               long weightMultiplier)

      Description copied from interface: `SimpleLongScoreHolder`
      Penalize a match by the `ConstraintWeight` negated and multiplied with the weightMultiplier for all score levels.
      Specified by:
        `penalize` in interface `SimpleLongScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `weightMultiplier` - at least 0

    - #### reward

          public void reward​(org.kie.api.runtime.rule.RuleContext kcontext)

      Description copied from interface: `ScoreHolder`
      Reward a match by the `ConstraintWeight`.
      Specified by:
        `reward` in interface `ScoreHolder<SimpleLongScore>`
      Parameters:
        `kcontext` - never null, the magic variable in DRL

    - #### reward

          public void reward​(org.kie.api.runtime.rule.RuleContext kcontext,
                             long weightMultiplier)

      Description copied from interface: `SimpleLongScoreHolder`
      Reward a match by the `ConstraintWeight` multiplied with the weightMultiplier for all score levels.
      Specified by:
        `reward` in interface `SimpleLongScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `weightMultiplier` - at least 0

    - #### impactScore

          public void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext,
                                  Object... justifications)

      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Overrides:
        `impactScore` in class `AbstractScoreHolder<SimpleLongScore>`
      Parameters:
        `kcontext` - never null
        `justifications` - the primary arguments(s) that the CS penalizes/rewards, not used outside of CS-D

    - #### impactScore

          public void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext,
                                  int weightMultiplier,
                                  Object... justifications)

      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Specified by:
        `impactScore` in class `AbstractScoreHolder<SimpleLongScore>`
      Parameters:
        `kcontext` - never null
        `weightMultiplier` - any
        `justifications` - the primary arguments(s) that the CS penalizes/rewards, not used outside of CS-D

    - #### impactScore

          public void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext,
                                  long weightMultiplier,
                                  Object... justifications)

      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Specified by:
        `impactScore` in class `AbstractScoreHolder<SimpleLongScore>`
      Parameters:
        `kcontext` - never null
        `weightMultiplier` - any
        `justifications` - the primary arguments(s) that the CS penalizes/rewards, not used outside of CS-D

    - #### impactScore

          public void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext,
                                  BigDecimal weightMultiplier,
                                  Object... justifications)

      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Specified by:
        `impactScore` in class `AbstractScoreHolder<SimpleLongScore>`
      Parameters:
        `kcontext` - never null
        `weightMultiplier` - any
        `justifications` - the primary arguments(s) that the CS penalizes/rewards, not used outside of CS-D

    - #### addConstraintMatch

          public void addConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext,
                                         long weight)

      Specified by:
        `addConstraintMatch` in interface `SimpleLongScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `weight` - higher is better, negative for a penalty, positive for a reward

    - #### extractScore

          public SimpleLongScore extractScore​(int initScore)

      Specified by:
        `extractScore` in class `AbstractScoreHolder<SimpleLongScore>`